<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of shortcodes
 *
 * @author anthony.humes
 */
class SMW_Controllers_Admin_CustomPostType extends SMW_Controllers_Abstract {
        private static $instance;
        private function __construct() {
            
        }
        public static function getInstance() {
            if(!isset(self::$instance)) {
                $className = __CLASS__;
                self::$instance = new $className;
            }
            return self::$instance;
        }
        function rewriteFlush() {
	  $this->create_post_type();
	  flush_rewrite_rules();
	}
	function createPostType() {
            $post_form = SMW::getControl('admin/custom-post-type/forms');
            $forms = SMW::getHelper('forms');
            
            $meta_boxes = $post_form->galleryPostFields();
            
            $array_keys = array_keys($meta_boxes);
        
            if($_POST[$meta_boxes[$array_keys[0]]['name']]) {
                $forms->saveForm( $meta_boxes, true );
            }
            $labels = array(
                'name' => __( get_option('smw_post_type_name') ),
                'singular_name' => __( get_option('smw_post_type_singular_name') ),
                'add_new' => __( get_option('smw_post_type_add_new') ),
                'view_item' => __( get_option('smw_post_type_view_item') ),
                'search_items' => __( get_option('smw_post_type_search_items') ),
                'add_new_item' => __( get_option('smw_post_type_add_new_item') ),
                'edit_item' => __( get_option('smw_post_type_edit_item') ),
                'menu_name' => __( get_option('smw_post_type_menu_item') ),
                );
            $args = array(
                'labels' => $labels,
                'public' => true,
                'has_archive' => true,
                'hierarchical' => true,
                'capability_type' => 'page',
                
                'supports' => array(
                    'title',
                    'editor',
                    'page-attributes'
                    ),
                'taxonomies' => array( 'post_tag','category'),
                'rewrite' => array(
                    'slug' => get_option('smw_post_type_slug')
                    ),
                );
            register_post_type( 'smw-gallery',$args );
	}
	public function addOptionsToPage() {
		$forms = SMW::getControl('admin/custom-post-type/forms');
		//print_r($this->templates);
		add_meta_box( 'smugpress-meta-boxes', __('SmugMug Options'), array(&$forms,'pageMetaBoxes'), 'smw-gallery', 'normal', 'default' );
	}
	function defaultTemplate() {
            global $post;

            $gallery_template = get_post_meta($post->ID,'smw_custom_post_template',true);

            if ( $gallery_template == '' )
                    add_post_meta( $post->ID, 'smw_custom_post_template', 'default', true );
			
	}
        
        
}
