<?php

class SMW_Controllers_Items_Type_Galleries extends SMW_Controllers_Items_CompositeItem {
    private static $instance;
    private function __construct() {
        $this->db = $this->getItemDb('galleries');
        $this->service = $this->getItemService('gallery');
        $this->category = $this->getItemService('category');
        $this->sub_category = $this->getItemService('sub-category');
        $this->images = $this->getItemDb('images');
    }
    public static function getInstance() {
        if(!isset(self::$instance)) {
            $className = __CLASS__;
            self::$instance = new $className;
        }
        return self::$instance;
    }
    public function getCount( $passworded = false ) {
        if($passworded) {
            return $this->db->getCount( $passworded );
        } else {
            return $this->db->getCount();
        }
    }
    public function getItem( $id, $array = null ) {
        return $this->db->selectItem( $id, $array );
    }
   
    public function gallerySizes( $sizes ) {
        $gallery_sizes = array(
            'Originals' => 0,
            'X3Larges' => 0,
            'X2Larges' => 0,
            'XLarges' => 0,
            'Larges' => 0,
        );
        switch( $sizes ) {
            case 'Originals':
                $gallery_sizes['Originals'] = 1;
                $gallery_sizes['X3Larges'] = 1;
                $gallery_sizes['X2Larges'] = 1;
                $gallery_sizes['XLarges'] = 1;
                $gallery_sizes['Larges'] = 1;
                break;
            case 'X3Larges':
                $gallery_sizes['X3Larges'] = 1;
                $gallery_sizes['X2Larges'] = 1;
                $gallery_sizes['XLarges'] = 1;
                $gallery_sizes['Larges'] = 1;
                break;
            case 'X2Larges':
                $gallery_sizes['X2Larges'] = 1;
                $gallery_sizes['XLarges'] = 1;
                $gallery_sizes['Larges'] = 1;
                break;
            case 'XLarges':
                $gallery_sizes['XLarges'] = 1;
                $gallery_sizes['Larges'] = 1;
                break;
            case 'Larges':
                $gallery_sizes['Larges'] = 1;
                break;
        }
        return $gallery_sizes;
    }
    public function delete_gallery_callback() {
        $id = $_POST['gallery_id'];
        $name = $_POST['name'];
        $response = $this->service->deleteItem( $id );
        if(!$response) {
            echo "<td colspan='9'><div id='message' class='updated'><p><strong>Gallery {$name} Deleted</strong></p><p>The album {$name} was successfully deleted! All pictures and data were deleted too from ".SMW_SERVICE.".</p></div></td>";
        } else {
            echo "<td colspan='9'><div id='message' class='error'><p><strong>Gallery {$name} Failed to be Deleted</strong></p><p>The album {$name} was was not deleted from ".SMW_SERVICE.".</p></div></td>";
        }
        die();
    }
    
    public function editGalleryAjax() {
        $form_fields = $_POST['form_data'];
        $form_fields = explode('&',$form_fields);
        foreach($form_fields as $form_field) {
            $form_data = explode('=',$form_field);
            if($form_data[0] == 'Sizes') {
                $form_sizes = $this->gallerySizes( $form_data[1] );
                //print_r($form_sizes);
                foreach( $form_sizes as $key => $form_size ){
                    $form_information[$key] = $form_size;
                }
            } elseif($form_data[0] == 'Password') {
                if($form_data[1]) {
                    $form_information['Passworded'] = 1;
                    $form_information[$form_data[0]] = str_replace('+', ' ', $form_data[1]);
                } else {
                    $form_information['Passworded'] = 0;
                    $form_information[$form_data[0]] = str_replace('+', ' ', $form_data[1]);
                }
                
            } else {
                $form_information[$form_data[0]] = str_replace('+', ' ', $form_data[1]);
            }
        }
        $update = $this->updateItem( $form_information, $_POST['id'] );
        print_r($form_information);
        die();
    }
    public function updateItem( $item, $id ) {
        $service = $item;
        $response['wordpress'] = $this->db->updateItem( $item, $id );
        $service['AlbumID'] = $id;
        $response['service'] = $this->service->updateItem( $service );
        return $response;
    }
    public function getServiceOnly() {
        $service_galleries = $this->service->getItems();
        $wordpress_galleries = $this->db->selectAll('id',true);
        
        foreach($service_galleries as $gallery) {
            $exists = $this->arraySearch($gallery['id'], $wordpress_galleries);
            
            if(!$exists) {
                $idKey = $gallery['id'] . '|' . $gallery['Key'];
                $galleries[] = $this->service->getItems($idKey);
            }
        }
        return $galleries;
    }
    public function getAll() {
        return $this->db->selectAll();
    }
    public function getAllForms() {
        $galleries = $this->db->selectAll( NULL, true);
        for($j = 0; $j < count($galleries); $j++) {
                $result_list[$j]['value'] = $galleries[$j]['gallery_id'];
                $result_list[$j]['name'] = $galleries[$j]['title'];
        }
        return $result_list;
    }
    public function saveItem($form_fields) {
        foreach( $form_fields as $key => $form_field ) {
            if(!empty($form_field) || $form_field == '0') {
                $form_data[$key] = $form_field;
            }
        }
        if(!empty($form_data['NewCategoryName'])) {
            $form_data['CategoryID'] = $this->category->createItem( array('Name' => $form_data['NewCategoryName']) );
        }
        if(!empty($form_data['NewSubCategoryName'])) {
            $form_data['SubCategoryID'] = $this->sub_category->createItem( array('CategoryID' => $form_data['CategoryID'],'Name' => $form_data['NewSubCategoryName']) );
        }
        unset($form_data['SaveToDatabase']);
        unset($form_data['NewCategoryName']);
        unset($form_data['NewSubCategoryName']);
        $new_gallery = $this->service->createItem($form_data);
        if($form_fields['SaveToDatabase']) {
            $idKey = $new_gallery['id'] . '|' . $new_gallery['Key'];
            $gallery = $this->service->getItems($idKey);
            $this->db->addItem($gallery);
        }
        if($new_gallery) {
            return $new_gallery;
        } else {
            return false;
        }
        
    }
    public function getUrl() {
        
    }
    public function getThumbUrl() {
        
    }
    public function getCaption() {
        
    }
    public function getImageCount( $id ) {
        return $this->db->selectVar('image_count', $id);
    }
    public function getGallery_callback() {
        $type = $_POST['type'];
        switch($type) {
            case 'wordpress':
                $this->galleries = $this->getAll();
                if($this->galleries) {
                    SMW::getBlock('admin/galleries/wordpress-galleries');
                } else {
                    echo "<div id='message' class='updated'><p><strong>No " . SMW_SERVICE . " Galleries are in Wordpress</strong></p><p>All of your " . SMW_SERVICE . " galleries are NOT in the Wordpress database.</p></div>";
                }
                break;
            case 'service':
                $this->service_galleries = $this->getServiceOnly();
                if($this->service_galleries) {
                    SMW::getBlock('admin/galleries/service-galleries');
                } else {
                    echo "<div id='message' class='updated'><p><strong>All " . SMW_SERVICE . " Galleries in Wordpress</strong></p><p>All of your " . SMW_SERVICE . " galleries are in the Wordpress database.</p></div>";
                }
                
                break;
        }
        
        die();
    }
    public function syncAllGalleries_callback() {
        $galleries = $this->db->selectVars( 'gallery_id, gallery_key, last_updated, image_count', true );
        foreach($galleries as $gallery) {
            $idKey = $gallery['gallery_id'] .'|'. $gallery['gallery_key'];
            $service = $this->service->getItems( $idKey );
            
            $new['last_updated'] = array($gallery['last_updated'],$service['LastUpdated']);
            $new['image_count'] = array($gallery['image_count'],$service['ImageCount']);
            if($gallery['last_updated'] != $service['LastUpdated'] || $gallery['image_count'] != $service['ImageCount']) {
                
                $this->images->removeGallery( $gallery['gallery_id'] );
                $images = $this->images->addGallery( $idKey );
                //$this->removeItem( $gallery['gallery_id'] );
                
            }
            $this->db->updateItem( $service, $gallery['gallery_id'] );
            //print_r($service);
        }
        
        die();
    }
    public function addAllGalleries_callback() {
        $this->galleries = $this->getServiceOnly();
        foreach($this->galleries as $gallery) {
            $this->db->addItem( $gallery );
            $idKey = $gallery['id'].'|'.$gallery['Key'];
            $this->images->addGallery( $idKey );
        }
        die();
    }
    public function excludeAllGalleries_callback() {
        $this->galleries = $this->getAll();
        foreach($this->galleries as $gallery) {
            $this->removeItem( $gallery->gallery_id );
        }
        die();
    }
    public function add_gallery_callback() {
        $images = $this->addItem( $_POST['gallery_id_key'] );
        
        die();
    }
    public function isPassworded( $id ) {
        return $this->db->selectVar( 'passworded',$id );
    }
    public function getPassword( $id ) {
        return $this->db->selectVar( 'password',$id );
    }
    public function getPasswordHint( $id ) {
        return $this->db->selectVar( 'password_hint',$id );
    }
    public function addItem( $idKey ) {
        $gallery = $this->service->getItems( $idKey );
        $this->db->addItem( $gallery );
        $images = $this->images->addGallery( $idKey );
        return $images;
    }
    public function exclude_gallery_callback() {
        $this->removeItem( $_POST['gallery_id'] );
        die();
    }
    public function removeItem( $id, $service = false ) {
        if( $service ) {
            $this->service->removeItem( $id );
        } elseif($service == 'all') {
            $this->db->removeItem( $id );
            $this->service->removeItem( $id );
        } else {
            $this->db->removeItem( $id );
        }
        
    }
    public function getTemplate() {
        
    }
}
