<?php

class SMW_Helpers_AddAjaxOptions {
    private static $instance;
    private function __construct() {
        $images = SMW::getItem('images');
        $galleries = SMW::getItem('galleries');
        $categories = SMW::getItem('categories');
        $subcategories = SMW::getItem('sub-categories');
        $settings = SMW::getControl('admin/settings');
        add_action('wp_ajax_remove_auth',array('SMW_Views_Admin_Settings','remove_auth_callback'));
        add_action('wp_ajax_settingsAjax',array($settings,'settingsAjax'));
        add_action('wp_ajax_subcategories_get',array(&$subcategories,'subcategories_get_callback'));
        add_action('wp_ajax_gallery_create',array('SMW_Controllers_Admin_Galleries_Create','gallery_create_callback'));
        add_action('wp_ajax_exclude_gallery',array(&$galleries,'exclude_gallery_callback'));
        add_action('wp_ajax_caption_save',array(&$images,'caption_save_callback'));
        add_action('wp_ajax_delete_gallery',array(&$galleries,'delete_gallery_callback'));
        add_action('wp_ajax_add_gallery',array(&$galleries,'add_gallery_callback'));
        add_action('wp_ajax_syncAllGalleries',array(&$galleries,'syncAllGalleries_callback'));
        add_action('wp_ajax_addAllGalleries',array(&$galleries,'addAllGalleries_callback'));
        add_action('wp_ajax_excludeAllGalleries',array(&$galleries,'excludeAllGalleries_callback'));
        add_action('wp_ajax_getGalleries',array(&$galleries,'getGallery_callback'));
        add_action('wp_ajax_imagesAjax',array(&$images,'imagesAjax'));
        add_action('wp_ajax_editAjax',array(&$images,'editAjax'));
        add_action('wp_ajax_hiddenAjax',array(&$images,'hiddenAjax'));
        add_action('wp_ajax_editGallery',array(&$galleries,'editGalleryAjax'));
        add_action('wp_ajax_imageHide',array(&$images,'imageHideAjax'));
        add_action('wp_ajax_imageEXIF',array(&$images,'imageEXIFAjax'));
        add_action('wp_ajax_categoryChange',array(&$categories,'categoryAdminChange'));
        add_action('wp_ajax_subCategoryChange',array(&$subcategories,'subCategoryAdminChange'));
        
    }
    public static function getInstance() {
        if(!isset(self::$instance)) {
            $className = __CLASS__;
            self::$instance = new $className;
        }
        return self::$instance;
    }
}
