<?php

// This is a helper class to make paginating 
// records easy.
class SMW_Helpers_Pagination {
	
  public $current_page;
  public $per_page;
  public $total_count;

  public function __construct($page=1, $per_page=20, $total_count=0){
    $this->current_page = (int)$page;
    $this->per_page = (int)$per_page;
    $this->total_count = (int)$total_count;
    $this->total_pages = $this->total_pages();
  }

  public function offset() {
    // Assuming 20 items per page:
    // page 1 has an offset of 0    (1-1) * 20
    // page 2 has an offset of 20   (2-1) * 20
    //   in other words, page 2 starts with item 21
    return ($this->current_page - 1) * $this->per_page;
  }

  public function total_pages() {
  	if($this->per_page == 0) {
  		$this->total_count = 1;
  	} else {
    	return ceil($this->total_count/$this->per_page); 		
  	}

	}
	
  public function previous_page() {
    return $this->current_page - 1;
  }
  
  public function next_page() {
    return $this->current_page + 1;
  }

	public function has_previous_page() {
		return $this->previous_page() >= 1 ? true : false;
	}

	public function has_next_page() {
		return $this->next_page() <= $this->total_pages() ? true : false;
	}
	public function items_per_page($item_array) {
		echo '<select name="imgPage" id="imgPage">';
		foreach($item_array as $item) {
			if((int)$item) {
				if($this->per_page == $item){
					echo '<option value="'.$item.'" selected="selected">'.$item.'</option>';
				} else {
					echo '<option value="'.$item.'">'.$item.'</option>';
				}
			} elseif($item == 'All') {
				if($this->per_page == $item){
					echo '<option value="'.$item.'" selected="selected">'.$item.'</option>';
				} else {
					echo '<option value="'.$item.'">'.$item.'</option>';
				}
			}
		}
		echo '</select>';
	}

	
	public static function create_pagination_ajax($currentPage=1,$range,$totalPages) {
		if($currentPage != 1) {
				echo '<span id="'.($currentPage - 1).'" class="page">&laquo; Previous</span>';
			}
			if($currentPage >= ($range + 3)) {
				echo '<span id="1" class="page">1</span>';
				echo '<span id="'.$totalPages.'" class="ellipse">...</span>';
			} elseif ($currentPage == ($range + 2)) {
				echo '<span id="1" class="page">1</span>';
			}
			for($i = ($currentPage - $range);$i < (($currentPage + $range) + 1); $i++) {
				if(($i > 0) && ($i <= $totalPages)){
					if($i == $currentPage){
						echo '<span id="'.$i.'" class="current">'.$i.'</span>';
					} else {
						echo '<span id="'.$i.'" class="page">'.$i.'</span>';
					}
				}
			}
			if($currentPage < ($totalPages - $range - 1)) {
				echo '<span id="'.$totalPages.'" class="ellipse">...</span>';
				echo '<span id="'.$totalPages.'" class="page">'.$totalPages.'</span>';
			} elseif ($currentPage == ($totalPages - $range - 1)) {
				echo '<span id="'.$totalPages.'" class="page">'.$totalPages.'</span>';
			}
			if($currentPage != $totalPages) {
				echo '<span id="'.($currentPage + 1).'" class="page" style="margin-right:0;">Next &raquo;</span>';
			}
	}
	function curPageURL() {
	 
	}
        
	//public function create_pagination_static($currentPage=1,$range,$totalPages) {
	public function create_pagination_static($range) {
		$pageURL = parse_url($_SERVER['REQUEST_URI'],PHP_URL_PATH);
		 //print_r($pageURL);
		if($this->current_page != 1) {
                        if(($this->current_page - 1) == 1) {
                                $pagination .= '<a href="'.$pageURL.'" id="'.($this->current_page - 1).'" class="page previous">&laquo; Previous</a>';
                        } else {
                                $pagination .= '<a href="'.$pageURL.'?page='.($this->current_page - 1).'" id="'.($this->current_page - 1).'" class="page previous">&laquo; Previous</a>';
                        }
                }
                if($this->current_page >= ($range + 3)) {
                        $pagination .= '<a href="'.$pageURL.'" id="1" class="page">1</a>';
                        $pagination .= '<span href="'.$pageURL.'" id="'.$this->total_pages.'" class="ellipse">...</span>';
                } elseif ($this->current_page == ($range + 2)) {
                        $pagination .= '<a href="'.$pageURL.'?" id="1" class="page">1</a>';
                }
                for($i = ($this->current_page - $range);$i < (($this->current_page + $range) + 1); $i++) {
                    if(($i > 0) && ($i <= $this->total_pages)){
                        if($i == $this->current_page){
                            $pagination .= '<span href="'.$pageURL.'?page='.$i.'" id="'.$i.'" class="current">'.$i.'</span>';
                        } else {
                            if($i == 1) {
                                    $pagination .= '<a href="'.$pageURL.'" id="'.$i.'" class="page">'.$i.'</a>';
                            } else {
                                    $pagination .= '<a href="'.$pageURL.'?page='.$i.'" id="'.$i.'" class="page">'.$i.'</a>';
                            }

                        }
                    }
                }
                if($this->current_page < ($this->total_pages - $range - 1)) {
                        $pagination .= '<span id="'.$this->total_pages.'" class="ellipse">...</span>';
                        $pagination .= '<a href="'.$pageURL.'?page='.$this->total_pages.'" id="'.$this->total_pages.'" class="page">'.$this->total_pages.'</a>';
                } elseif ($this->current_page == ($this->total_pages - $range - 1)) {
                        $pagination .= '<a href="'.$pageURL.'" id="'.$this->total_pages.'" class="page">'.$this->total_pages.'</a>';
                }
                if($this->current_page != $this->total_pages) {
                        $pagination .= '<a href="'.$pageURL.'?page='.($this->current_page + 1).'" id="'.($this->current_page + 1).'" class="page next" style="margin-right:0;">Next &raquo;</a>';
                }
                //echo $pagination;
                return $pagination;        
	}
        public function create_pagination( $type, $range ) {
            switch($type) {
                case 'static':
                    return $this->create_pagination_static($range);
                    break;
            }
        }
}

?>