<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of templates
 *
 * @author anthony.humes
 */
class SMW_Helpers_Templates {
    private static $instance;
    private function __construct() {
        
    }
    public static function getInstance() {
        if(!isset(self::$instance)) {
            $className = __CLASS__;
            self::$instance = new $className;
        }
        return self::$instance;
    }
    function getFileExtension($file_name) {
            return substr(strrchr($file_name,'.'),1);
	}
        
        function directoryList($directory_base_path,$type) {
            $directory_base_path = rtrim($directory_base_path, "/") . "/";

             // create an array to hold directory list
	    $results = array();
	
	    // create a handler for the directory
	    $handler = opendir($directory_base_path);
		$i = 0;
	    // open directory and walk through the filenames
	    while ($file = readdir($handler)) {
			$extension = $this->getFileExtension($file);

		    // if file isn't this directory or its parent, add it to the results
		    if(!is_dir($directory_base_path . $file) && $extension == 'php') {
			    if ($file != "." && $file != "..") {
					$withoutExt = pathinfo($file, PATHINFO_FILENAME);
					$results[] = $withoutExt;
				}
		    }
		    $i++;
	    }
	
	    // tidy up: close the handler
	    closedir($handler);
	
	    // done!
	    return $results;
	}
        
	function getTemplates($template_dir,$type=false,$name) 
	{
		//ALT_TEMPLATE_DIR
		if($type == 'gallery') {
                    $gallery_dir = $template_dir .'galleries/';
                    if(is_dir($gallery_dir)) {
                        $template_dir = $gallery_dir;
                    } else {
                        $template_dir = SMW_ALT_TEMPLATE_DIR .'galleries/';
                    }
                    
		} elseif($type == 'widget') {
                    $widget_dir = $template_dir .'widgets/';
                    if(is_dir($widget_dir)) {
                        $template_dir = $widget_dir;
                    } else {
                        $template_dir = SMW_ALT_TEMPLATE_DIR .'widgets/';
                    }
                }
                
		$templates = $this->directoryList($template_dir,$type);
		
		$post_templates = array();
		
		if ( is_array( $templates ) ) {
			
			
			$j = 0;
			foreach ( $templates as $template ) {
				$basename = $template_dir . $template.'.php';//str_replace($base, '', $template['value'].'.php');
				
				$template_data[$j] = htmlentities(implode( '', file( $basename )));
				
				if ( preg_match( '|'.$name.':(.*)$|mi', $template_data[$j], $name_new ) )
                                    $name_new = _cleanup_header_comment( $name_new[1] );

				if ( !empty( $name_new ) && !is_array($name_new) ) {
					$post_templates[$j]['value'] = $template;
					$post_templates[$j]['name'] = $name_new;
				}
				$j++;
			}
		}
                
		return $post_templates;
	}
}
