<?php



class SMW_Helpers_Url {
    private static $instance;
    private function __construct() {
        $default = get_option( 'smw_service_url' );
        $service_url = get_option( 'smw_default_service_url' );
        if( !$service_url || $service_url == '://' ) {
            $this->base_url = 'http://' . get_option('smw_service_url');
        } else {
            $this->base_url = 'http://' . get_option('smw_default_service_url');
        }
        
        $this->lightbox_type = get_option('smw_lightbox_type');
    }
    public static function getInstance() {
        if(!isset(self::$instance)) {
            $className = __CLASS__;
            self::$instance = new $className;
        }
        return self::$instance;
    }
    function finalURL($url) {
        $path = $this->parse($url,'path');
        $final_url = $this->base_url . $path;
        return $final_url;
    }
    function videoURL($image,$width,$height,$video_size) {
        switch($this->lightbox_type) {
            case 'prettyphoto':
                $video_url = $this->finalURL($image[$video_size]) . '?width='.$width.'&height='.$height;
                break;
            case 'clearbox':
                $video_url = $this->finalURL($image[$video_size]);
                break;
        }
        return $video_url;
    }
    public function parse( $url, $type ) {
        $parsed_url = parse_url($url);
        switch($type) {
            case 'domain':
                $url_final = $parsed_url['scheme'] . '://' . $parsed_url['host'];
                break;
            case 'path':
                $url_final = $parsed_url['path'];
                break;
            case 'no-http':
                $url_final = $parsed_url['host'];
                break;
            default:
                $url_final = $url;
                break;
        }
        return $url_final;
    }
}
