<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of view
 *
 * @author anthony.humes
 */
class SMW_Views_Admin_Albums_Create_View extends SMW_Views_Abstract {
    private static $instance;
    private function __construct() {
        $this->albumDb = SMW::getModel('wordpress/items/albums');
        $this->forms = SMW::getHelper('forms');
    }
    public static function getInstance() {
        if(!isset(self::$instance)) {
            $className = __CLASS__;
            self::$instance = new $className;
        }
        return self::$instance;
    }
    public function createFields() {
        $categories = array(
            array( 'name' => 'Thumb', 'value' => 'ThumbURL' ),
            array( 'name' => 'Tiny', 'value' => 'TinyURL' ),
            array( 'name' => 'Small', 'value' => 'SmallURL' ),
            array( 'name' => 'Medium', 'value' => 'MediumURL' ),
        );
        $thumbnails = array(
            array( 'name' => '320', 'value' => 'Video320URL' ),
            array( 'name' => '640', 'value' => 'Video640URL' ),
            array( 'name' => '960', 'value' => 'Video960URL' ),
            array( 'name' => '1280', 'value' => 'Video1280URL' ),
            array( 'name' => '1920', 'value' => 'Video1920URL' ),
        );
        $sizes = array();
        $sortDirection = array();
        $sortMethod = array();
        /* Array of the meta box options. */
        $meta_boxes = array(
            'default_smugmug_album' => array( 'name' => 'smw_default_service_url', 'title' => __('Default SmugMug URL', 'smw'), 'type' => 'text', 'description' => 'Change this ONLY if you want your photos to come from your SmugMug url (http://example.smugmug.com) instead of your custom SmugMug URL.', 'size' => 40 ),
            'default_images_number' => array( 'name' => 'smw_default_images_number', 'title' => __('Number of Images', 'smw'), 'type' => 'text', 'description' => 'Default number of images to show in your galleries.', 'size' => 10 ),
            'default_thumb_size' => array( 'name' => 'smw_default_thumb_size', 'options' => $default_thumb_sizes, 'title' => __('Default Thumbnail Size', 'smw'), 'type' => 'select' ),
            'default_viewable_size' => array( 'name' => 'smw_default_viewable_size', 'options' => $default_viewable_sizes, 'title' => __('Default Lightbox Size', 'smw'), 'type' => 'select' ),
            'default_video_size' => array( 'name' => 'smw_default_video_size', 'options' => $default_video_sizes, 'title' => __('Default Video Size', 'smw'), 'type' => 'select', 'description' => 'The number is the number of pixels to the longest side.' ),
           'jquery_frontend' => array( 'name' => 'smw_jquery_frontend', 'title' => __('Enable jQuery on Frontend', 'smw'), 'type' => 'boolean', 'description' => 'This is loads the jQuery script included in Wordpress on the Frontend. Disable if there are conflicts.' ),
            'caption_frontend' => array( 'name' => 'smw_caption_frontend', 'title' => __('Enable Image Captions', 'smw'), 'type' => 'boolean', 'description' => 'Set to NO if you need to disable your captions on the frontend.' ),
            

        );

        return apply_filters( 'smw_post_meta_boxes', $meta_boxes );
    }
    public function showPage() {
        $this->form_items = $this->createFields();
        SMW::getBlock('admin/albums/create/main');
    }
}